package neuroet;

import javax.swing.*;
import javax.swing.text.*;
import java.awt.*;

public final class DoubleFilterDocument extends PlainDocument
{

	private final JTextComponent theField;
        private final double min;
        private final double max;


	public DoubleFilterDocument(JTextComponent associatedField)
	{
	    super();
	    theField = associatedField;
            min = Double.NEGATIVE_INFINITY;
            max = Double.POSITIVE_INFINITY;

	}

        public DoubleFilterDocument(JTextComponent associatedField, double mn, double mx)
        {
            super();
            theField = associatedField;
            min = mn;
            max = mx;

        }



	public void insertString (int offset, String string, AttributeSet attributeSet) throws BadLocationException
	{
		String current = theField.getText();

		try{
			double dub = new Double (current.substring(0,offset) + string + current.substring(offset)).doubleValue();
		if ( dub < min || dub > max)
			throw new NumberFormatException(); //ensures positive values

		super.insertString (offset, string, attributeSet);


		}catch(NumberFormatException e){Toolkit.getDefaultToolkit().beep();}



	}

}