package neuroet;

import javax.swing.*;
import java.awt.*;
/**
 * <p>Title: Neural Net Classes</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: University of Washington</p>
 * @author Erik Tribou
 * @version 1.0
 */

public class LabeledSlider extends JPanel
{
  private final JSlider mySlider;
  private final JLabel val;

  LabeledSlider(String lab, int min, int max, int def, int tickSpacing)
  {

    super();

    setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

    JPanel top = new JPanel(new FlowLayout(FlowLayout.LEFT));
    //JPanel bottom = new JPanel(new FlowLayout(FlowLayout.LEFT));

    mySlider = new JSlider(min, max, def);
    val = new JLabel(Integer.toString(def));

    top.add(new JLabel(lab + ":"));
    top.add(val);


    mySlider.addChangeListener(new SliderListener(mySlider, val));



    mySlider.setMajorTickSpacing(tickSpacing);
    mySlider.setPaintTicks(true);
    mySlider.setPaintLabels(true);

    mySlider.setBorder(new javax.swing.border.EmptyBorder(0, 10, 0, 10));//need to give it some space since it's not in a panel



    //bottom.add(mySlider);
    Utilities.FixMaximumSize(top);
    add(top);
    mySlider.setPreferredSize(mySlider.getPreferredSize());
    Utilities.FixMaximumSize(mySlider);
    add(mySlider);
    //add(bottom);

  }

  public int getValue()
  {
    return mySlider.getValue();
  }
}