package neuroet;


public final class NoBiasNeuron extends Neuron
{
        private final static long serialVersionUID= 264849802L;

	NoBiasNeuron(int ni, ActivationFunction a )
	{
		super(ni, a);
		bias = 0.0;
	}

	private NoBiasNeuron (double[] ws, ActivationFunction activ)
	{
		super(ws, 0, activ);
	}

	public void ModifyAll(int start, double[] mods)
	{

		for (int x = 0; x < weights.length; x++)
		{
			weights[x] += mods[start + x];
		}

	}

	public void AdjustWeightsAndBiases(double sensitivity)//used in standard backprop
	{

		for (int x = 0; x < weights.length; x++)
		{
			weights[x] -= lr * sensitivity * previousInputs[x];
		}

		//bias -= lr * sensitivity;
	}


	public void CalculateGradient(double sensitivity, int position, double[] toStickInto)  //gives us the gradient
	{


		for (int x = 0; x < weights.length; x++)
		{
			toStickInto[position++] =  sensitivity * previousInputs[x];
		}

		//toStickInto[position] = sensitivity;//don't need to increment position


	}

	public int SizeGradient()
	{
		return weights.length;
	}

	public final Neuron copy()
	{
		return new NoBiasNeuron((double[])weights.clone(),AF);
	}

}