package neuroet;

import java.util.Comparator;

/**
 * <p>Title: Neural Net Classes</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: University of Washington</p>
 * @author Erik Tribou
 * @version 1.0
 */

public final class ObjectDoubleHolder
{

  private final Object o;
  private final double d;

  ObjectDoubleHolder(Object n, double u)
  {
    o = n;
    d = u;
  }

  public Object GetObject()
  {
    return o;
  }

  public double GetDouble()
  {
    return d;
  }

  public String toString()
  {
    return o + "\t" + d;
  }





  public static final Comparator doubleAscending = new Comparator()
  {
    public int compare(Object o1, Object o2)
    {
      double x1 = ((ObjectDoubleHolder)o1).GetDouble();
      double x2 = ((ObjectDoubleHolder)o2).GetDouble();

      if (x1 > x2)
         return 1;
      if (x1 < x2)
         return -1;
      return 0;

    }
  };

  public static final Comparator doubleDescending = new Comparator()
  {
    public int compare(Object o1, Object o2)
    {
      double x1 = ((ObjectDoubleHolder)o1).GetDouble();
      double x2 = ((ObjectDoubleHolder)o2).GetDouble();

      if (x1 > x2)
         return -1;
      if (x1 < x2)
         return 1;
      return 0;

    }
  };

}