package neuroet;

/**
 * <p>Title: Neural Net Classes</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: University of Washington</p>
 * @author Erik Tribou
 * @version 1.0
 */

import javax.swing.*;
import java.io.*;

public class Startup
{
  public static void main (String[] args) throws Exception
  {

    if (args.length == 4)
    {
      try{
      Startup.DoCommandLine(args);
      }catch(Throwable t){t.printStackTrace();}
      System.exit(0);
    }


      System.out.println("Starting up");
      
	//CHANGE add the invoke later call
	
	SwingUtilities.invokeLater(new Runnable()
	{
		public void run()
		{
			new UI().init();
		}
	});
      

      System.out.println("Ready to rock!");


  }


  static private void DoCommandLine(String[] args) throws IOException
  {
    if (args.length != 4)
      throw new IllegalArgumentException("Bad Number of Args");


    final int hiddenUnits = Integer.parseInt(args[0]);

    File inputs = new File(args[1]);
    File output = new File(args[2]);
    File resultsFile = new File(args[3]);


    PrefPanel def = new PrefPanel(null, "");
    DataSet toUse = new DataSet(inputs, output, 0.0, 0.0, def);

    NeuronMaker nm = new NeuronMaker()
    {
      public Neuron GetOutputNeuron(int numHidden)
      {
        return new Neuron(numHidden, ActivationFunction.PureLinear);
      }

      public void SetNumberHidden(int num)
      {
        throw new java.lang.UnsupportedOperationException();
      }

      public Neuron[] GetHiddenNeurons(int numInputs)
      {
        Neuron[] toReturn = new Neuron[hiddenUnits];

        for (int x = 0; x < toReturn.length; x++)
        {
          toReturn[x] = new Neuron(numInputs, ActivationFunction.HyperbolicTangentSigmoid);

        }

        return toReturn;
      }
    };



    File resultsDirectory = Utilities.GenerateDirectory(new File(""));

    try{
    File toWriteTo = new File(resultsDirectory, "results.txt");



    new XInputAnalyzer(toUse, nm, resultsDirectory, 2,1.0,"", 1, 15).run();

    resultsFile.delete();
    if (toWriteTo.renameTo(resultsFile) == false)
      throw new IOException("Couldn't Copy Results File");

    }finally{Utilities.DeleteWholeTree(resultsDirectory);}

  }

}
