package neuroet;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.util.List;
import javax.swing.border.*;
/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Erik Tribou
 * @version 1.0
 */




public class UI extends JApplet
{

private JFrame wind;

private PrefPanel pPanel;
private FileChoosingPanel NNLoadPanel;
private FileChoosingPanel NNInputPanel;
private FileChoosingPanel NNOutputPanel;
private FileChoosingPanel NN2InputPanel;
private JButton train;

static private final ProjectMonitor pm;

static{


  try
  {
    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());//ensures all UI elements are native
    //UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
  }catch (Exception e){System.err.println("Couldn't Set L&F: " + e.toString());}

	//CHANGE  Instead of parsing properties make this system call
  int numCPU = Runtime.getRuntime().availableProcessors();
	System.out.println("Neuroet Using: " + numCPU + " processor(s)");
  pm = new ProjectMonitor(numCPU);

}


    static public ProjectMonitor GetProjectMonitor()
    {
      return pm;
    }








        public void init ()
        {

                wind = new JFrame("Neuroet");

                wind.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);

                wind.addWindowListener(new WindowAdapter()
                {
                  public void windowClosing(WindowEvent e)
                  {
                    HandleQuit();
                  }
                });


                NNLoadPanel = new FileChoosingPanel(wind, "Choose the Neural Net to load", "Neural Net: ");
                NNInputPanel = new FileChoosingPanel(wind, "Choose the file containing the inputs","Inputs File: ");
                NNOutputPanel = new FileChoosingPanel(wind, "Choose the file containing the outputs","Outputs File: ");

                NN2InputPanel = new FileChoosingPanel(wind, "Choose the file containing the inputs","Inputs File: ");


                FileChoosingPanel.FixLabelWidths(NNInputPanel, NNOutputPanel);

                FileChoosingPanel.FixLabelWidths(NNLoadPanel, NN2InputPanel);


                //final FileChoosingPanel NN2OutputPanel = new FileChoosingPanel(wind, "Choose the file containing the outputs","Outputs (DataX):");


                JTabbedPane mp = new JTabbedPane();
				
				//CHANGE
				mp.setOpaque(true);
				wind.setContentPane(mp);

                //wind.getContentPane().add(mp);


                JPanel tPanel = new JPanel();
                tPanel.setLayout(new BoxLayout(tPanel, BoxLayout.Y_AXIS));

                tPanel.add(NNInputPanel);
                tPanel.add(NNOutputPanel);




                /*Designing the chooser panel*/
                JPanel trainingPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
                trainingPanel.add (new JLabel("Training Method:"));


                final JComboBox options = new JComboBox(Trainer.GetTrainerNames());

                trainingPanel.add (options);

                Utilities.FixMaximumSize(trainingPanel);
                tPanel.add (trainingPanel);


                JPanel threshPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));

                final JTextField thr = new JTextField(7);

                thr.setDocument(new DoubleFilterDocument(thr, 0.0, 1.0));
                thr.setText("1.0");

                thr.setCursor(Cursor.getPredefinedCursor(Cursor.TEXT_CURSOR));

                threshPanel.add(new JLabel("Threshold (R\u00B2):"));
                threshPanel.add(thr);


                Utilities.FixMaximumSize(threshPanel);
                tPanel.add(threshPanel);

                /*end designing*/


                JPanel buttonPanel = new JPanel();
                buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));

                final JCheckBox cb = new JCheckBox("Keep Best Generalizations");
                JPanel lPan = new JPanel(new FlowLayout(FlowLayout.LEFT));
                lPan.add(cb);



                train = new JButton("Train Network");


                JPanel rPan = new JPanel(new FlowLayout(FlowLayout.RIGHT));
                rPan.add(train);

                buttonPanel.add(lPan);
                buttonPanel.add(rPan);




                train.addActionListener(new ActionListener()
                {

                        public void actionPerformed(ActionEvent q)
                        {
                        File datay = NNOutputPanel.getFile();
                        File datax = NNInputPanel.getFile();



                        try{


                        if (datax == null)
                                throw new FileNotFoundException("Need a datax File");
                        if (datay == null)
                                throw new FileNotFoundException("Need a datay File");



                        DataSet ds = new DataSet(datax, datay, pPanel);




                        File sv = null;

                        try{
                          sv = Utilities.QueryForSaveFile(wind, "Save Results To:","NNResults");

                          sv.delete();

                          if (!sv.mkdir())
                          {
                            throw new IOException("Can't create new directory:" + sv);
                          }

                        }catch(FileNotFoundException fnfe){return;}


                        Runnable toRun = null;

                        if (cb.isSelected()) //do best generalization
                        {
                          toRun = new GeneralizedJob(pPanel.GenerateNeuronMaker(), ds, options.getSelectedIndex(), Double.parseDouble(thr.getText()), sv, "Training w/ Generalization: " + sv.getName());
                        }
                        else //do not keep best generalization
                        {
                          toRun = new TrainingJob(pPanel.GenerateNeuronMaker(), ds, options.getSelectedIndex(),Double.parseDouble(thr.getText()) , sv, "Training Job: " + sv.getName());
                        }

                        UI.GetProjectMonitor().Enqueue(toRun);


                      }catch(Exception e){JOptionPane.showMessageDialog(null,
                      "An error occurred while setting up the Neural Net: " + e,
                      "NN Run Exception", JOptionPane.ERROR_MESSAGE);e.printStackTrace();}



                        } //end function


                });//end class

                tPanel.add(Box.createVerticalGlue());

                Utilities.FixMaximumSize(buttonPanel);
                tPanel.add(buttonPanel);

                mp.addTab("Train Network", tPanel);


                JPanel testPanel = new JPanel();
                testPanel.setLayout(new BoxLayout(testPanel, BoxLayout.Y_AXIS));

                testPanel.add(NNLoadPanel);
                //testPanel.add(NN2OutputPanel);
                testPanel.add(NN2InputPanel);


                JPanel bPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));


                JButton run = new JButton("Run Network");

                bPanel.add(run);

                testPanel.add(Box.createVerticalGlue());

                Utilities.FixMaximumSize(bPanel);
                testPanel.add(bPanel);

                run.addActionListener(new ActionListener()
                {
                        public void actionPerformed(ActionEvent q)
                        {
                                File NN = NNLoadPanel.getFile();
                                File datax = NN2InputPanel.getFile();
                                File sv;

                                try{
                                if (NN == null)
                                        throw new FileNotFoundException("Need a Neural Net File");
                                if (datax == null)
                                        throw new FileNotFoundException("Need a datax File");

                                try
                                {
                                        sv = Utilities.QueryForSaveFile(wind,"Save Neural Net Output to:","NNOutput.txt");
                                }catch (FileNotFoundException e){return;}


                                NeuralNetJob r = new RunJob(NN, datax, sv, "Run Task: " + sv.getName());
                                UI.GetProjectMonitor().Enqueue(r);

                                }catch (Exception e){JOptionPane.showMessageDialog(null,
                                "An error occurred while running the Neural Net: " + e,
                                "NN Run Exception", JOptionPane.ERROR_MESSAGE); e.printStackTrace();}
                        }

                });



                mp.addTab("Run Neural Net",testPanel);



                mp.addTab("Measure Importance of Inputs", new ImportancePanel());
                mp.addTab("Optimize Hidden Neurons", new OptimizationPanel());

                //wind.setResizable(false);

                SetMenus(wind);



                pPanel = new PrefPanel(wind, "Preferences");


                
				  //CHANGE       
				  //Removed the invoke later call, we invoke later in Startup.Main instead
				  pm.pack();
				  Utilities.UpperRightWindow(pm);
				  pm.show();
	
	
				  //CHANGE
				  //Affects whether the main window can be resized or not
				  //wind.setResizable(false);
				  JComponent c = (JComponent)wind.getContentPane();
				  wind.pack();
				  c.setMinimumSize(c.getSize());
				  Utilities.CenterWindow(wind);
				  wind.show();

                  

        }

        private void SetMenus(Frame f)
        {
                MenuBar mb = new MenuBar();

                Menu File = new Menu("File");
                Menu Edit = new Menu("Edit");

                MenuItem about = new MenuItem("About Neuroet");
                MenuItem showQueue = new MenuItem("Show Task Queue",new MenuShortcut('T'));
                MenuItem quit = new MenuItem("Quit", new MenuShortcut('Q'));
                MenuItem undo = new MenuItem("Undo", new MenuShortcut('Z'));
                MenuItem cut = new MenuItem("Cut", new MenuShortcut('X'));
                MenuItem copy = new MenuItem("Copy", new MenuShortcut('C'));
                MenuItem paste = new MenuItem("Paste", new MenuShortcut('V'));
                MenuItem preferences = new MenuItem("Preferences", new MenuShortcut(';'));

                MenuItem analData = new MenuItem ("Pre-Analyze Data", new MenuShortcut('D'));



                undo.setEnabled(false);
                cut.setEnabled(false);
                copy.setEnabled(false);
                paste.setEnabled(false);

                File.add(about);
                File.add(analData);
                File.add(showQueue);
                File.add(quit);

                Edit.add(undo);
                Edit.addSeparator();
                Edit.add(cut);
                Edit.add(copy);
                Edit.add(paste);
                Edit.addSeparator();
                Edit.add(preferences);

                mb.add(File);
                mb.add(Edit);

                showQueue.addActionListener(new ActionListener()
                {
                  public void actionPerformed(ActionEvent ae)
                  {
                    UI.GetProjectMonitor().show();
                  }
                });

                analData.addActionListener(new ActionListener()
                {
                  private JFrame f= new DataPreAnalyzer();//only frame is in this listener
                  public void actionPerformed(ActionEvent ae)
                  {
                   f.show();
                  }
                });

                about.addActionListener(new ActionListener()
                {
                  public void actionPerformed(ActionEvent e)
                  {
                    AboutBox.display();
                  }
                });

                quit.addActionListener(new ActionListener()
                {
                        public void actionPerformed(ActionEvent e)
                        {
                                HandleQuit();
                        }
                }

                );


                preferences.addActionListener(new ActionListener()
                {
                        public void actionPerformed(ActionEvent e)
                        {
                                pPanel.show();
                        }
                }

                );

                f.setMenuBar(mb);
        }

        private void HandleQuit()
        {
          int opt = JOptionPane.showConfirmDialog(wind, "Do you really wish to quit?", "Quit?", JOptionPane.YES_NO_OPTION);

          if (opt == JOptionPane.YES_OPTION)
            System.exit(0);
        }

    	public File GetInputFile() throws FileNotFoundException
	{
		File tr = NNInputPanel.getFile();

		if (!tr.canRead())
			throw new FileNotFoundException("Can't Read Input File");

		return tr;
	}

	public File GetOutputFile() throws FileNotFoundException
	{
		File tr = NNOutputPanel.getFile();

		if (!tr.canRead())
			throw new FileNotFoundException("Can't Read Output File");

		return tr;
	}


    class OptimizationPanel extends JPanel
    {
      private final FileChoosingPanel inp;
      private final FileChoosingPanel outp;
      private final JComboBox method;
      private final JComboBox optMeth;
      private final LabeledSlider slider;

      OptimizationPanel()
      {
        super();
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

        inp = new FileChoosingPanel(wind, "Choose the file containing the inputs","Inputs File: ");
        outp = new FileChoosingPanel(wind, "Choose the file containing the outputs","Outputs File: ");

        FileChoosingPanel.FixLabelWidths(inp, outp);

        slider = new LabeledSlider("Max Hidden Neurons", 1, 99, 2, 10);

        /*JPanel slideState = new JPanel(new FlowLayout(FlowLayout.LEFT));
        slideState.add(new JLabel("Max Hidden Nodes: "));
        JLabel numLab = new JLabel("88");

        numLab.setPreferredSize(numLab.getPreferredSize());//a bit of a hack so we don't get movement when sliding

        slideState.add(numLab);

        //JPanel sliderPanel = new JPanel();

        slider = new JSlider(1, 51, 10);

        slider.setMajorTickSpacing(10);
        slider.setPaintTicks(true);
        slider.setPaintLabels(true);

        slider.addChangeListener(new SliderListener(slider, numLab));
        slideState.add(slider);

        //sliderPanel.add(slider);

        */



        JPanel tm = new JPanel(new FlowLayout(FlowLayout.LEFT));

        tm.add(new JLabel("Training Method:"));
        method = new JComboBox(Trainer.GetTrainerNames());

        tm.add(method);

        JPanel bot = new JPanel();

        bot.setLayout(new BoxLayout(bot, BoxLayout.X_AXIS));

        JPanel leftBot = new JPanel(new FlowLayout(FlowLayout.LEFT));
        JPanel rightBot = new JPanel(new FlowLayout(FlowLayout.RIGHT));

        leftBot.add(new JLabel("Optimization Method: "));

        optMeth = new JComboBox(HiddenUnitOptimizer.GetNames());
		optMeth.setSelectedIndex(HiddenUnitOptimizer.GetNames().length-1); // make last one default (AICc score)
        leftBot.add(optMeth);


        final JButton optimize = new JButton("Optimize");

        rightBot.add(optimize);

        bot.add(leftBot);

        bot.add(rightBot);

        add(inp);
        add(outp);

        //add(tp);
        Utilities.FixMaximumSize(tm);
        add(tm);
        Utilities.FixMaximumSize(slider);
        add(slider);
        //add(slideState);

        add(Box.createVerticalGlue());
        Utilities.FixMaximumSize(bot);

        add(bot);

        optimize.addActionListener(new ActionListener()
        {

         public void actionPerformed(ActionEvent q)
         {
          File i = inp.getFile();
          File o = outp.getFile();

          try{
          if (i == null || o == null || !i.canRead() || !o.canRead())
             throw new IOException("No Inputs or Outputs File Specified, or no permissions to read");

          try{
          Runnable toDo= null;

          DataSet toUse = new DataSet(i, o, 0.0, 0.0, pPanel);


          File saveFile = Utilities.QueryForSaveFile(wind, "Save Results to: ","Optimization Results.txt");

          saveFile.delete();


          toDo = new OptimizationJob("Optimization Job: " + saveFile.getName(), toUse, pPanel.GenerateNeuronMaker(),
                                     HiddenUnitOptimizer.ResolveName((String)optMeth.getSelectedItem()), method.getSelectedIndex(), slider.getValue(),saveFile);



          pm.Enqueue(toDo);


          }catch(FileNotFoundException fnfe){return;}

          }catch(Exception e){JOptionPane.showMessageDialog(null, "An error has occurred: " + e,
                              "NN Analysis Error", JOptionPane.ERROR_MESSAGE);}



         }
        });


      }

    }

    class ImportancePanel extends JPanel
    {
    private final FileChoosingPanel inp;
    private final FileChoosingPanel outp;
    private final JComboBox method;
    private final LabeledSlider slider;
    //JTextField thr;

    ImportancePanel()
    {
      super();
      setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

      inp = new FileChoosingPanel(wind, "Choose the file containing the inputs","Inputs File: ");
      outp = new FileChoosingPanel(wind, "Choose the file containing the outputs","Outputs File: ");

      FileChoosingPanel.FixLabelWidths(inp, outp);

      JPanel tm = new JPanel(new FlowLayout(FlowLayout.LEFT));

      tm.add(new JLabel("Training Method:"));
      method = new JComboBox(Trainer.GetTrainerNames());

      tm.add(method);

      slider = new LabeledSlider("Runs per Combination", 1, 99, 15, 10);

      /*JPanel slideState = new JPanel(new FlowLayout(FlowLayout.LEFT));
      slideState.add(new JLabel("Runs/combination: "));
      JLabel numLab = new JLabel("88");

      numLab.setPreferredSize(numLab.getPreferredSize());//a bit of a hack so we don't get movement when sliding

      slideState.add(numLab);

      //JPanel sliderPanel = new JPanel();

      slider = new JSlider(1, 99, 10);

      slider.setMajorTickSpacing(10);
      slider.setPaintTicks(true);
      slider.setPaintLabels(true);

      slider.addChangeListener(new SliderListener(slider, numLab));
      slideState.add(slider);
      */

      JPanel bot = new JPanel();

      bot.setLayout(new BoxLayout(bot, BoxLayout.X_AXIS));

      JPanel leftBot = new JPanel(new FlowLayout(FlowLayout.LEFT));
      JPanel rightBot = new JPanel(new FlowLayout(FlowLayout.RIGHT));

      leftBot.add(new JLabel("Mode: "));

      //final JRadioButton oneOut = new JRadioButton("One-Out", true);
      //final JRadioButton oneIn = new JRadioButton("One-In", false);


      //ButtonGroup bg = new ButtonGroup();
      //bg.add(oneOut);
      //bg.add(oneIn);


      //leftBot.add(oneOut);
      //leftBot.add(oneIn);

      final JComboBox num = new JComboBox(new String[]{"1", "2", "3", "4", "5"});
      final JComboBox inOrOut = new JComboBox(new String[]{"In", "Out"});

      leftBot.add(num);
      leftBot.add(inOrOut);


      final JButton testInputs = new JButton("Test Inputs");

      rightBot.add(testInputs);

      bot.add(leftBot);
      bot.add(rightBot);

      add(inp);
      add(outp);

      //add(tp);
      Utilities.FixMaximumSize(tm);
      add(tm);
      Utilities.FixMaximumSize(slider);
      add(slider);
      //add(slideState);
      //add(Box.createVerticalStrut(inp.getPreferredSize().height));//compensates for missing threshold panel
      add(Box.createVerticalGlue());

      Utilities.FixMaximumSize(bot);
      add(bot);

      testInputs.addActionListener(new ActionListener()
      {

       public void actionPerformed(ActionEvent q)
       {
        File i = inp.getFile();
        File o = outp.getFile();

        try{
        if (i == null || o == null || !i.canRead() || !o.canRead())
           throw new IOException("No Inputs or Outputs File Specified, or no permissions to read");

        try{
        Runnable toDo= null;

        DataSet toUse = new DataSet(i, o, 0.0, 0.0, pPanel);


        File saveFolder = Utilities.QueryForSaveFile(wind, "Save Results to: ","InputAnalyzerResults");

          saveFolder.delete();
          saveFolder.mkdir();

        if (inOrOut.getSelectedIndex() == 1)
        {

          toDo = new XOutInputAnalyzer(toUse, pPanel.GenerateNeuronMaker(), saveFolder,
        method.getSelectedIndex(), 1.0/*Double.parseDouble(thr.getText())*/, "Exclusive Input Analyzer: " + saveFolder.getName(), num.getSelectedIndex() + 1, slider.getValue());

        }
        else
        {

//2input analyzer
          toDo = new XInputAnalyzer(toUse, pPanel.GenerateNeuronMaker(), saveFolder,
        method.getSelectedIndex(), 1.0/*Double.parseDouble(thr.getText())*/, "Inclusive Input Analyzer: " + saveFolder.getName(), num.getSelectedIndex() + 1, slider.getValue());
        }

        pm.Enqueue(toDo);


        }catch(FileNotFoundException fnfe){return;}

        }catch(Exception e){JOptionPane.showMessageDialog(null, "An error has occurred: " + e,
                            "NN Analysis Error", JOptionPane.ERROR_MESSAGE);}



       }
      });


    }



}


}






/*class ThreadSequenceRunner implements Runnable
{
  Runnable[] toRun;

  ThreadSequenceRunner(Runnable[] tr)
  {
    toRun = (Runnable[])tr.clone();
  }

  public void run()
  {
    for (int x = 0; x < toRun.length; x++)
    {
      try{
      toRun[x].run();
      }catch(Throwable t){t.printStackTrace();}//log errors but continue running
    }
  }

}*/


class AboutBox
{
   static private final JFrame myFrame;

   static{
    myFrame = new JFrame("About Neuroet");

    try{
    myFrame.getContentPane().add(new JLabel(Utilities.GetImageFromResource("support/b.gif")));
    }catch(IOException io){System.err.println("Couldn't Load About Box"); System.exit(-5);}
    myFrame.setResizable(false);
    myFrame.pack();
   }

   static public void display()
   {
    if (!myFrame.isVisible())
      Utilities.CenterWindow(myFrame);
    myFrame.show();
   }



}

class DataPreAnalyzer extends JFrame
{
  private JFrame self;

  DataPreAnalyzer()
  {
    super("Data Analyzer");
    self = this;
    Container ct = this.getContentPane();
    ct.setLayout(new BoxLayout(ct, BoxLayout.Y_AXIS));

    final FileChoosingPanel fcp = new FileChoosingPanel(this, "Choose the input file:", "Input File");

    ct.add(fcp);

    final JCheckBox skew = new JCheckBox("Skew",true);
    final JCheckBox kurtosis = new JCheckBox("Kurtosis",true);
    final JCheckBox relationship = new JCheckBox("Relationships",true);

    JLabel l = new JLabel("Options:");

    JPanel a = new JPanel(new FlowLayout(FlowLayout.LEFT));
    JPanel b = new JPanel(new FlowLayout(FlowLayout.LEFT));
    JPanel c = new JPanel(new FlowLayout(FlowLayout.LEFT));
    JPanel d = new JPanel(new FlowLayout(FlowLayout.LEFT));

    a.add(l);
    b.add(skew);
    c.add(kurtosis);
    d.add(relationship);

    ct.add(a);
    ct.add(b);
    ct.add(c);
    ct.add(d);

    JButton r = new JButton("Run");
    JPanel g = new JPanel(new FlowLayout(FlowLayout.RIGHT));


    r.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        try{
          File toRead = fcp.getFile();
          if (!toRead.canRead())
             throw new IOException("Need to define a file to read");

          File ts = null;

          try{
            ts = Utilities.QueryForSaveFile(self,"Save Results To: ","DataAnalysis.txt");
          }catch(IOException i){return;}


          BufferedReader in = new BufferedReader(new FileReader(toRead));

          String f = null;

          for (f = in.readLine();; f = in.readLine())
          {
            if (f == null)
            {
                throw new IOException("Nothing found in input file");
            }

            f = f.trim();

            if (f.equals(""))
            {
              continue;
            }

            break;

          }

          String[] names = Utilities.GetAllCategories(new StringTokenizer(f, "\t"));

                //double[][] inputs = Utilities.ReadMatrix(Utilities.ReadAll(in));


          double[][] data = ArrayUtilities.RotateMatrix(Utilities.ReadMatrix(Utilities.ReadAll(in)));//read the data so we know it is valid before we put it on the queue

          boolean s = skew.isSelected();
          boolean k = kurtosis.isSelected();
          boolean r = relationship.isSelected(); //need to determine these beforehand


          UI.GetProjectMonitor().Enqueue(new PreAnalyzeJob(s, k, r, data, names, ts, "Preanalyze Job: " + ts.getName()));


        }catch(Exception x){JOptionPane.showMessageDialog(null,
                            "An error has occurred while setting up a preanalysis job: " + x,
                            "Data Analysis Error", JOptionPane.ERROR_MESSAGE); /*return;*/}
        //JOptionPane.showMessageDialog(null, "Data Analysis Finished", "Notification", JOptionPane.INFORMATION_MESSAGE);
      }
    });

    g.add(r);

    ct.add(g);
    setResizable(false);
    pack();


  }


  public static void PreAnalyze(double[][] data, String[] names, File toSave, boolean skew, boolean kurtosis, boolean relationship) throws IOException
  {

    if (names.length != data.length)
      throw new IllegalArgumentException("Number of names doesn't match data");

    PrintWriter pw = new PrintWriter(new FileWriter(toSave));

          if (skew)
          {

            pw.println("Skew Report:  High Skew suggests one should perform a log or square-root transformation");
            pw.println();

            for (int x = 0; x < data.length; x++)
            {
              pw.println("Variable " + names[x] + ":\t" + ArrayUtilities.CalculateSkew(data[x]));
            }

            pw.println();
            pw.println("---------------");
            pw.println();
          }

          if (kurtosis)
          {


            pw.println("Kurtosis Report:  High Kurtosis but low skew suggests one should perform an arctan transformation on the data");
            pw.println();

            for (int x = 0; x < data.length; x++)
            {
              pw.println("Variable " + names[x] + ":\t" + ArrayUtilities.CalculateKurtosis(data[x]));
            }

            pw.println();
            pw.println("---------------");
            pw.println();


          }

          if (relationship)
          {


            pw.println("Relationships Report:  True means a relationship probably (.995) exists");
            pw.println();

            for (int x = 0; x < data.length; x++)
            {
              for (int y = 0; y < data.length; y++)
              {
                if (y == x)
                   continue;

                pw.print("Variables " + names[x] + " & " + names[y] + ":\t");
                try{
                  pw.println(ArrayUtilities.CalculateRunCorrelation(data[x], data[y]));
                }catch(IllegalArgumentException iae){pw.println("Unknown: " + iae.getMessage());}

              }
            }


          }
          //Utilities.PrintDoubleMatrix(pw, ArrayUtilities.RotateMatrix(data));
          pw.close();


  }


}



class ProjectMonitor extends JFrame//JWindow
{
  private final JPanel cp;
  private final JList myList;
  private final JList currentRunning;
  //private final JLabel current;

  private final ThreadWaiter tw;

  private final ThrobLabel tl;

  private static final MouseListener ListListener = new MouseAdapter()
  {
    public void mouseClicked(MouseEvent e) {
     if (e.getClickCount() == 2) {
         JList list = (JList)e.getSource();
         Object o = list.getSelectedValue();

         if (o != null)
         {
           NeuralNetJob nnj = (NeuralNetJob)o;
           nnj.ShowStatus();
         }
      }
    }
  };



  ProjectMonitor(int numThreads)
  {
    super("Task Queue");

    if (numThreads < 1)
      throw new IllegalArgumentException("Bad value for numThreads: " + numThreads);

    cp = new JPanel();
    this.setContentPane(cp);

    //cp = getContentPane();
    //cp.setLayout(new BorderLayout());
    myList = new JList();

    JScrollPane sp = new JScrollPane(myList, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);

    //current = new JLabel("Currently Running: 0");


    tw = new ThreadWaiter(numThreads, NeuralNetJob.GetFinishedHandler());//might not be compatible

    myList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    myList.setModel(tw);
    //myList.setPreferredSize(new Dimension(300, 150));

    sp.setBorder(new TitledBorder(sp.getBorder(), "Waiting:"));

    currentRunning = new JList();

    currentRunning.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    currentRunning.setModel(tw.GetRunningList());


    myList.addMouseListener(ListListener);
    currentRunning.addMouseListener(ListListener);

    //currentRunning.setPreferredSize(new Dimension(300, 80));


    JScrollPane osp = new JScrollPane(currentRunning, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);

    //osp.setPreferredSize(new Dimension(300, 80));

    osp.setBorder(new TitledBorder(osp.getBorder(), "Currently Running:"));

    //JPanel bottomPanel = new JPanel();
    //bottomPanel.setLayout(new BoxLayout(bottomPanel, BoxLayout.Y_AXIS));

    JButton bu = new JButton("Remove Waiting Task");
    //JPanel textPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));



    JPanel throbPanel = new JPanel();
    JPanel buttPanel = new JPanel();
    buttPanel.add(bu);
    ImageIcon one = null;


    ImageIcon two = null;

    try{
      one = Utilities.GetImageFromResource("support/braininactive.gif");
      two = Utilities.GetImageFromResource("support/brainactive.gif");
    }catch(IOException io){System.err.println("Couldn't load brain: " + io); System.exit(-5);}

    tl = new ThrobLabel(one, two);


    throbPanel.add(tl);
    //textPanel.add(current);
    buttPanel.add(bu);

    //bottomPanel.add(textPanel);
    //bottomPanel.add(throbPanel);
    //bottomPanel.add(buttPanel);

    cp.setLayout(new BoxLayout(cp, BoxLayout.Y_AXIS));

    cp.add(osp);
    cp.add(sp);

    cp.add(buttPanel);

    cp.add(throbPanel, buttPanel);





    bu.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {

        synchronized(tw)
        {
          Object o = myList.getSelectedValue();

          if (o != null)
          {
            tw.RemoveObject(o);
            NeuralNetJob.GetFinishedHandler().run((NeuralNetJob)o);//clean up a removed job
          }
        }
      }
    });


    setResizable(false);



  }


  public void Enqueue(Runnable r)
  {

    synchronized(tw)
    {
      if (tw.isEmpty())
        new Watcher().start();

      tw.add(r);
    }

  }


  class Watcher extends Thread
  {
    public void run()
    {
      javax.swing.Timer t = new javax.swing.Timer(1500, new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {
          tl.Swap();//performed on event thread
        }
      });

      t.setRepeats(true);

      t.start();

      try{
        tw.waitTillFinished();
      }catch(InterruptedException ie){}

      t.stop();

      SwingUtilities.invokeLater(new Runnable()
      {
        public void run()
        {
          tl.Reset();//ensures we have a pict of a non-thinking brain
        }
      });


      java.awt.Toolkit.getDefaultToolkit().beep();
      JOptionPane.showMessageDialog(null, "All jobs are finished", "Notification of Completion", JOptionPane.INFORMATION_MESSAGE);

    }
  }




}


final class ThreadWaiter extends AbstractListModel
{
  private final List list;

  private final Object self;
  private int current;


  private final JobFinishedHandler doOnCompletion;


  private final RunningModel runningList;


  final class RunningModel extends AbstractListModel
  {

    private final List rl;

    RunningModel()
    {
      super();
      rl = Collections.synchronizedList(new LinkedList());
    }

    public synchronized Object getElementAt(int x)
    {
      return rl.get(x);
    }

    public synchronized int getSize()
    {
      return rl.size();
    }

    public synchronized void add (Object o)
    {
      rl.add(o);
      int size = rl.size() - 1;
      fireIntervalAdded(this, size, size);
    }

    public synchronized void remove (Object o)
    {
      int index = rl.indexOf(o);

      if (index > -1)
      {
        rl.remove(index);
        fireIntervalRemoved(this, index, index);
      }

    }

  }


  public ListModel GetRunningList()
  {
    return runningList;
  }

  public synchronized void RemoveObject(Object o)
  {

    int index = list.indexOf(o);

    if (index > -1)
    {
      list.remove(index);

      fireIntervalRemoved(this, index, index);
    }

  }

  public synchronized Object getElementAt(int nd)
  {
    return list.get(nd);
  }

  public synchronized int getSize()
  {
    return list.size();
  }

  public ThreadWaiter(int maxRun)
  {
    this(maxRun, null);
  }


  public ThreadWaiter(int maxRun, JobFinishedHandler toDo)
  {
    super();

    self = this;


    if (maxRun < 1)
       throw new IllegalArgumentException("Illegal Value for max run: " + maxRun);

    current = 0;

    list = Collections.synchronizedList(new LinkedList());

    runningList = new RunningModel();

    for (int x = 0; x < maxRun; x++)
    {
      Thread t = new ThreadRunner();

      t.setPriority(Thread.NORM_PRIORITY -1);
      t.start();
    }

    doOnCompletion = toDo;

  }

  private synchronized void IncrementCurrent()
  {
    current++;
  }

  private synchronized int GetCurrent()
  {
    return current;
  }

  private synchronized void DecrementCurrent()
  {

      if (--current == 0 && list.isEmpty())
      {
        notifyAll();
      }

  }

  class ThreadRunner extends Thread
  {
    public void run()
    {
      Runnable task = null;

      for (;;)
      {
          synchronized(self)
          {
              while (list.isEmpty())
              {
                  try{
                    self.wait();
                  }catch(InterruptedException ie){ie.printStackTrace();}
              }


              IncrementCurrent();//need to increment before removing object from list
              task = (Runnable)list.remove(0);

              fireIntervalRemoved(self, 0, 0);
           }



        try{
          runningList.add(task);
          task.run();

        }catch (Throwable t){t.printStackTrace();Utilities.ShowErrorMessage(t);}
        finally{runningList.remove(task);}//always clean up


        if (doOnCompletion != null)
           doOnCompletion.run(task);

        task = null;
        DecrementCurrent();


      }
    }
  }



  public synchronized boolean isEmpty()
  {

      return (GetCurrent() == 0 && list.isEmpty());

  }

  public synchronized void add(Runnable r)
  {
      list.add(r);
      int size = list.size() - 1;
      fireIntervalAdded(this, size, size);
      notifyAll();
  }


  //only decrement current should lock the object itself as only it notifies

  public synchronized void waitTillFinished() throws InterruptedException
  {
      while (!isEmpty())
      {
        wait();
      }

  }




}

interface JobFinishedHandler
{
  public void run(Runnable r);
}

class ThrobLabel extends JLabel
{
  private final ImageIcon one;
  private final ImageIcon two;

  private ImageIcon current;

  public ThrobLabel(ImageIcon o, ImageIcon t)
  {
    one = o;
    two = t;
    current = one;
    setIcon(current);
  }

  public void Reset()
  {
    if (current != one)
      Swap();
  }


  public void Swap()
  {
    current = (current == one) ? two: one;
    setIcon(current);
  }

}


abstract class NeuralNetJob implements Runnable, Serializable
{

  private transient final JFrame w;
  private transient final String name;
  private transient final JTextArea tf;
  private transient final ActionListener updater;
  private transient static final javax.swing.Timer tim;


  static
  {
    ActionListener doNothing = new ActionListener(){public void actionPerformed(ActionEvent evt){}};
    tim = new javax.swing.Timer(2000,doNothing);
    tim.removeActionListener(doNothing);
    tim.start();
  }


  NeuralNetJob(String s)
  {
    name = s;
    w = new JFrame(name);
    Container c = w.getContentPane();



    tf = new JTextArea(5, 50);
    tf.setEditable(false);
    JScrollPane jsp = new JScrollPane(tf,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    c.add(jsp);

    w.setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);

    w.addWindowListener(new WindowAdapter()
    {

      public void windowOpened(WindowEvent e)
      {
        tim.addActionListener(updater);
      }

      public void windowClosed(WindowEvent e)
      {
        tim.removeActionListener(updater);
      }

    });

    updater = new ActionListener()
    {
      public void actionPerformed(ActionEvent evt)
      {
          tf.setText(GetStatus());
      }
    };

  }

  private static final JobFinishedHandler jfh = new JobFinishedHandler()
  {
    public void run (Runnable r)
    {
      ((NeuralNetJob)r).CleanUp();
    }
  };

  public static JobFinishedHandler GetFinishedHandler()
  {
    return jfh;
  }

  public final void CleanUp()//safe to call from any thread
  {
    if (SwingUtilities.isEventDispatchThread())
    {
      w.hide();
      w.dispose();
    }
    else
    {
      SwingUtilities.invokeLater(new Runnable()
      {
        public void run()
        {
          CleanUp();
        }
      });
    }

  }

  public final void ShowStatus()//is safe to show on any thread
  {
      if (SwingUtilities.isEventDispatchThread())
      {
        if (!w.isVisible())
        {
          tf.setText(GetStatus());
          w.pack();
          Utilities.AlmostCenterWindow(w);
        }

        w.show();
      }
      else
      {
        SwingUtilities.invokeLater(new Runnable()
        {
          public void run()
          {
            ShowStatus();
          }
        });
      }

  }


  public abstract String GetStatus();

  public abstract void run();


  public String toString()
  {
    return name;
  }

}

class TrainingJob extends NeuralNetJob
{
  private final NeuralNet n;
  private final File saveDir;
  private final int to;
  private final DataSet ds;
  private final double thresh;


  public TrainingJob(NeuronMaker nm, DataSet d , int trainOpt, double thld, File sf, String name)
  {
    super(name);
    n = new NeuralNet(d, nm);
    saveDir = sf;
    to = trainOpt;
    thresh = thld;
    ds = d;
  }

  public String GetStatus()
  {
    return "Current R-Squared: " + n.GetError();
  }


  public void run()
  {
    try{
    n.GetGenericTrain(to, thresh, saveDir).run();
    DataSet.PrintDataSetToFiles(ds,new File(saveDir,"dataOut.txt"), new File(saveDir,"data2X.txt"), new File(saveDir,"data2Y.txt" ));
    }catch(Throwable t){JOptionPane.showMessageDialog(null,
    "An error occurred while running the Neural Net: " + t,
    "NN Run Exception", JOptionPane.ERROR_MESSAGE);t.printStackTrace();}
  }


}

class GeneralizedJob extends NeuralNetJob
{

private NeuralNet n;
private final NeuronMaker nm;
private final File saveDir;
private final int to;
private final DataSet ds;
private final double thresh;
private int currRun;
private final static int numRuns = 10;

  public GeneralizedJob(NeuronMaker nem, DataSet d, int trainOpt, double thld, File sf, String name)
  {
    super(name);

    if (d.GetTestingOutput().length == 0 || d.GetValidationOutput().length == 0)
      throw new IllegalStateException("Need testing and validation data");

    nm = nem;
    saveDir = sf;
    to = trainOpt;
    thresh = thld;
    ds = d;
    currRun = 0;
  }

  public synchronized String GetStatus()
  {
    if (n != null)
    {
      return "Job Number: " + currRun + "\t" + "Current R-Squared: " + n.GetError();
    }
    else
    {
      return "Starting Job Number: " + currRun;
    }

  }


  public void run()
  {

    try{

      for (int x = 0; x < numRuns; x++)
      {
        File saveFolder = new File(saveDir, "Run" + (x + 1));

        if (!saveFolder.mkdir())
        {
          throw new IOException("Couldn't make folder: " + saveFolder);
        }

        synchronized(this)
        {
          currRun++;
          n = new NeuralNet(ds, nm);
        }

        n.GetTrainWithBestGeneralization(to, thresh, saveFolder).run();
      }

      DataSet.PrintDataSetToFiles(ds,new File(saveDir,"dataOut.txt"), new File(saveDir,"data2X.txt"), new File(saveDir,"data2Y.txt" ));

    }catch(Throwable t){JOptionPane.showMessageDialog(null,
    "An error occurred while running the Neural Net: " + t,
    "NN Run Exception", JOptionPane.ERROR_MESSAGE);t.printStackTrace();}

  }


}


class RunJob extends NeuralNetJob
{
  private final File save;
  private final File NN;
  private final File datax;

  RunJob(File n, File da,File sf, String name)
  {
    super(name);
    NN = n;
    save = sf;
    datax = da;
  }

  public String GetStatus()
  {
    return "Not Finished yet...";
  }

  public void run()
  {
    try{
      NeuralNet.RunNeuralNetOnData(NN, datax, save);
    }catch(Throwable t){JOptionPane.showMessageDialog(null,
    "An error occurred while running the Neural Net: " + t,
    "NN Run Exception", JOptionPane.ERROR_MESSAGE);t.printStackTrace();}
  }


}

class PreAnalyzeJob extends NeuralNetJob
{
  private final boolean skew;
  private final boolean kurtosis;
  private final boolean correlation;
  private final double[][] data;
  private final File saveFile;

  private final String[] names;

  PreAnalyzeJob(boolean s, boolean k, boolean c, double[][] d, String[] n, File sf, String name)
  {
    super(name);
    skew = s;
    kurtosis = k;
    correlation = c;
    data = d;
    saveFile = sf;
    names = n;
  }

  public String GetStatus()
  {
    return "Not Finished yet...";
  }

  public void run()
  {
    try{
      DataPreAnalyzer.PreAnalyze(data, names, saveFile, skew, kurtosis, correlation);
    }catch (IOException ie){JOptionPane.showMessageDialog(null,
                  "An io error has occurred in DataPreAnalyzer: " + ie,
                  "IO Error", JOptionPane.ERROR_MESSAGE); }
  }


}

class XInputAnalyzer extends NeuralNetJob
{
  protected final DataSet mainDataSet;
  private final NeuronMaker nm;

  private final int numIter;
  private final int trainer;
  private final double threshold;
  protected final File saveFolder;

  private final int chs;
  private final int maxComb;

  private volatile int curr;
  private volatile int iter;

  XInputAnalyzer(DataSet ds, NeuronMaker nmkr, File svfl,int trnr, double thld, String name, int c, int ni)
  {

    super(name);
    chs = c;
    nm = nmkr;
    mainDataSet = ds;

    numIter = ni;

    if (c > ds.GetInputWidth())
      throw new IllegalArgumentException("Not enough input variables to do " + c + " in");

    if (c < 1)
      throw new IllegalArgumentException("Need a positive number to put in: " + c);


    maxComb = Utilities.Choose(ds.GetInputWidth(),chs);


    trainer = trnr;
    threshold = thld;
    saveFolder = svfl;

    curr = 0;
    iter = 0;

    if (!saveFolder.isDirectory())
      throw new IllegalArgumentException("Save folder should be a folder");

  }

  public String GetStatus()
  {
    return "On run "+ (iter + 1) + " of " + numIter + " for input combo " + (curr + 1) + " of " + maxComb;
  }

  public void run()
  {

    IntSetIterator isi = new IntSetIterator(0, mainDataSet.GetInputWidth() - 1, chs);


    //double[] finalRsquared = new double[numIter];

    NeuralNet[] neuralNets = new NeuralNet[numIter];

    //ObjectDoubleHolder[] inputRsquared = new ObjectDoubleHolder[maxComb];
    NeuralNet[] bestNNs = new NeuralNet[maxComb];
    double baseRsquared = 0.0;

    /*For each variable, keep just it in and train 11 times*/

    for (curr = 0; curr < bestNNs.length; curr++)
    {
      int[] currInps = isi.GetNext();

      DataSet currentDS = mainDataSet.ExtractXInputs(currInps);
      File fldr = new File(saveFolder, Integer.toString(curr));

      if (!fldr.mkdir())
      {
        throw new RuntimeException("Couldn't create folder: " + fldr);
      }

      try{
        DataSet.PrintDataSetToFiles(currentDS, new File(fldr, "dataOut.txt"), new File(fldr, "data2X.txt"), new File(fldr, "data2Y.txt"));
      }catch(Exception f){ throw new RuntimeException(f.toString());}

      for (iter = 0; iter < numIter; iter++)
      {
        NeuralNet nn = new NeuralNet(currentDS, nm);

        try{
          nn.DoIt(trainer, threshold);
        }catch(TrainingException te){}//just exit... reached a min
        catch(InterruptedException ie){ie.printStackTrace(); throw new RuntimeException("Got an Interrupted Exception while analyzing inputs " + ie);}


        neuralNets[iter] = nn;
        //finalRsquared[iter] = nn.GetError(); //get the final error

      }//end iter



      NeuralNet medVal = (NeuralNet)ArrayUtilities.GetXthPercentile(neuralNets, NeuralNetComparator.lowToHighR2, 0.75);//ArrayUtilities.CalculateMedian(finalRsquared);
      bestNNs[curr] = medVal;
      Arrays.fill(neuralNets, null);//gc
      //inputRsquared[curr] = new ObjectDoubleHolder(currInps, medVal);

    }//end curr

    DoPrinting(bestNNs);




  }

  protected void DoPrinting(NeuralNet[] bestNNs)
  {
    java.util.Arrays.sort(bestNNs, NeuralNetComparator.highToLowR2);

    try{
    PrintWriter pw = new PrintWriter(new FileWriter(new File(saveFolder, "Results.txt")));
    pw.println("This file contains the inputs in descending order of importance");
    pw.println("Rank" + "\t" + "Inputs Included" + "\t" + "R-Squared" + "\t" + "SBC Score" + "\t" + "AICc Score");
    pw.println();
    for (int x = 0; x < bestNNs.length; x++)
    {
      NeuralNet curr = bestNNs[x];
      String[] names = curr.GetInputNames();

      pw.print((x+1) + "\t");

      for (int y = 0; y < names.length; y++)
      {
        pw.print(names[y]);
        if (y != names.length -1)
        {
          pw.print(" & ");
        }
      }

      pw.print("\t");
      pw.println(curr.GetError() + "\t" + HiddenUnitOptimizer.GetFinalSBCScore(curr) + "\t" + HiddenUnitOptimizer.GetFinalAICcScore(curr));

      //pw.println((x + 1) + "\t" +  mainDataSet.GetColumnName(inputRsquared[x].GetInt()) + "\t" + inputRsquared[x].GetDouble());
    }

    pw.close();
    }catch(IOException ie){JOptionPane.showMessageDialog(null,
                            "An error occurred while writing our results: " + ie,
                            "NN Run Exception", JOptionPane.ERROR_MESSAGE);ie.printStackTrace();}

  }
}


class NeuralNetComparator
{
  public final static Comparator lowToHighR2= new Comparator()
  {
    public int compare (Object o1, Object o2)
    {
      double n1 = ((NeuralNet)o1).GetError();//r^2 values
      double n2 = ((NeuralNet)o2).GetError();

      if (n1 > n2)
        return 1;
      if (n1 < n2)
        return -1;
      return 0;

    }
  };


  public final static Comparator highToLowR2 = new Comparator()
  {
    public int compare (Object o1, Object o2)
    {
      double n1 = ((NeuralNet)o1).GetError();//r^2 values
      double n2 = ((NeuralNet)o2).GetError();

      if (n1 > n2)
        return -1;
      if (n1 < n2)
        return 1;
      return 0;

    }
  };

}



//one out
class XOutInputAnalyzer extends XInputAnalyzer
{


  XOutInputAnalyzer(DataSet ds, NeuronMaker nmkr, File svfl,int trnr, double thld, String name, int c, int ni)
  {
    super(ds, nmkr, svfl, trnr, thld, name, ds.GetInputWidth() - c, ni); //get the
  }

  protected void DoPrinting(NeuralNet[] bestNNs)
  {
    java.util.Arrays.sort(bestNNs, NeuralNetComparator.lowToHighR2);

    HashSet allNames = new HashSet(Arrays.asList(mainDataSet.GetInputNames()));

    try{
    PrintWriter pw = new PrintWriter(new FileWriter(new File(saveFolder, "Results.txt")));
    pw.println("This file contains the inputs in descending order of importance");
    pw.println("Rank" + "\t" + "Inputs Excluded" + "\t" + "R-Squared" + "\t" + "SBC Score" + "\t" + "AICc Score");
    pw.println();
    for (int x = 0; x < bestNNs.length; x++)
    {
      HashSet backup = (HashSet)allNames.clone();
      NeuralNet curr = bestNNs[x];

      allNames.removeAll(Arrays.asList(curr.GetInputNames()));

      String[] names = (String[])allNames.toArray(new String[0]);

      pw.print((x+1) + "\t");

      for (int y = 0; y < names.length; y++)
      {
        pw.print(names[y]);
        if (y != names.length -1)
        {
          pw.print(" & ");
        }
      }

      pw.print("\t");
      pw.println(curr.GetError() + "\t" + HiddenUnitOptimizer.GetFinalSBCScore(curr) + "\t" + HiddenUnitOptimizer.GetFinalAICcScore(curr));

      allNames = backup;
      //pw.println((x + 1) + "\t" +  mainDataSet.GetColumnName(inputRsquared[x].GetInt()) + "\t" + inputRsquared[x].GetDouble());
    }

    pw.close();
    }catch(IOException ie){JOptionPane.showMessageDialog(null,
                            "An error occurred while writing our results: " + ie,
                            "NN Run Exception", JOptionPane.ERROR_MESSAGE);ie.printStackTrace();}
    }

}


class OptimizationJob extends NeuralNetJob
{
  private volatile int numNodes;
  private volatile int runNum;

  private final HiddenUnitOptimizer opt;

  private final int maxNodes;
  private static final int maxRun = 15;

  private final File toWrite;

  private final DataSet ds;
  private final NeuronMaker nm;

  private final int trainer;

  OptimizationJob(String name, DataSet dat, NeuronMaker neur, HiddenUnitOptimizer o, int trn, int mn,File tw)
  {
    super(name);
    maxNodes = mn;
    trainer = trn;
    ds = dat;
    nm = neur;
    runNum = 0;
    numNodes = 1;
    opt = o;
    toWrite = tw;
  }

  public void run()
  {
    ObjectIntHolder[] ans = new ObjectIntHolder[maxNodes];


    for (numNodes = 1; numNodes <= maxNodes; numNodes++)
    {
      ObjectDoubleHolder[] scores = new ObjectDoubleHolder[maxRun];
      nm.SetNumberHidden(numNodes);


      for (runNum = 0; runNum < maxRun; runNum++)
      {
        NeuralNet nn = new NeuralNet(ds,nm);//generate new nn for each score

        try{
          nn.DoIt(trainer,1.0);
        }catch (TrainingException te){}
        catch(InterruptedException ie){ throw new RuntimeException(ie.toString());}


        scores[runNum] = new ObjectDoubleHolder(nn, nn.GetSSE());

        //scores[runNum] = opt.GetScore(trainer, nn);
      }


      ObjectDoubleHolder med = (ObjectDoubleHolder)ArrayUtilities.GetXthPercentile(scores, ObjectDoubleHolder.doubleDescending, 0.75);//ArrayUtilities.CalculateMedian(scores);
      ans[numNodes - 1] = new ObjectIntHolder(med.GetObject(),numNodes);
      Arrays.fill(scores, null);//for gc

    }

    Arrays.sort(ans, new Comparator()
    {
      public int compare (Object o1, Object o2)
      {

        double x1 = opt.GetScore((NeuralNet)(((ObjectIntHolder)o1).GetObject()));
        double x2 = opt.GetScore((NeuralNet)(((ObjectIntHolder)o2).GetObject()));

        if (x1 < x2)
          return -1;
        if (x1 > x2)
          return 1;
        return 0;

      }

    });

    PrintWriter out = null;

    try{
      out = new PrintWriter(new BufferedWriter(new FileWriter(toWrite)));

      out.println("Number\tSBC Score\tAICc Score");  // changed from # of hidden Nodes

      for (int x = 0; x < ans.length; x++)
      {
        NeuralNet n = (NeuralNet)ans[x].GetObject();
        out.println(ans[x].GetInt() + "\t" + HiddenUnitOptimizer.GetFinalSBCScore(n) + "\t" + HiddenUnitOptimizer.GetFinalAICcScore(n));
      }

      //Utilities.PrintObjectArray(out, ans);
      out.close();


    }catch(IOException io){JOptionPane.showMessageDialog(null,
                            "An error occurred while writing our results: " + io,
                            "NN Run Exception", JOptionPane.ERROR_MESSAGE);io.printStackTrace();}
  }

  public String GetStatus()
  {
    return "On run "+ (runNum + 1) + " of " + maxRun + " for number of hidden neurons " + (numNodes) + " of " + maxNodes;
  }

}
